<id>
Catagorized Random Quotes SP1-1.2
</id>

<version>
1.0
</version>

<mod info>
With this mod, you can use the [rquote] or [rquote=??] ubbc tags to insert random quotes into your messages.

These quotes can be grouped together into catagories, and the catagory to use specified by using the tag [rquote=??] where ?? is the name of the catagory.
The lists of random quotes can be edited in the admin center, where extra catagories can also be added. (There is no limit to the number of catagories you can have.)
If you use the tag [rquote] without specifying a catagory, YaBB will use the "default" catagory, so make sure you create a catagory with the name "default"!

Notes:
1: Instructions on how to install mods can be found at http://boardmod.yabbforum.com/
2: Catagories can be created, edited or deleted from the admin center by clicking on the "Edit Random Quotes" link.
3: Random quotes will change every time you view them!
4: You can use both HTML and UBBC tags in your random quotes, but be careful of certain character combinations in your html tags which could be mistaken for UBBC code.
   (in particular, make sure urls are surrounded by "double quotes", and watch out for anything that could be interpreted as a smiley :)
5: Depending on your server, Catagory names may be case sensitive!
6: You can also include random quotes in your template using <yabb rquote> or <yabb rquote=??> where ?? is the name of the catagory.
7: You can include [rquote=??] tags in the random quotes list to link other catagories together.
   ie: create a catagory called "random", containing [rquote=??] tags to all the other catagories. then adding [rquote=random] to your message will insert a random quote from any of the other catagories.
   (a check has been included to only allow one recursive [rquote] tag, otherwise certain catagory/tag configurations could cause the script to go into an endless loop.)  


Credits:
Thanks to Jake for suggestions, comments and feedback.
</mod info>

<author>
BHRA Webmaster, Jake
</author>

<homepage>
http://www.bhra.org.uk
</homepage>

#############################################################################################################

<edit file>
YaBB.pl
</edit file>

<search for>  
		elsif ($action eq 'modagreement2') { require "$sourcedir/AdminEdit.pl"; &ModifyAgreement2; }
</search for>  
  
<add after>
		elsif ($action eq 'modquotes') { require "$sourcedir/Admin.pl"; &ModifyQuotes; }
		elsif ($action eq 'modquotes2') { require "$sourcedir/Admin.pl"; &ModifyQuotes2; }
</add after>

#############################################################################################################

<edit file>
english.lng
</edit file>

<search for>
if($MenuType == 1) {
</search for>

<add before>
### Catagorised Random Quotes ###
	$crq_txt{'1'} = "Edit Random Quotes";
	$crq_txt{'2a'} = "This form allows you to edit the random quotes contained in each catagory. Use the drop-down box to select the catagory, or select 'New Catagory' and enter the catagory name in the box provided. (And if you don't have a &quot;default&quot; catagory to use with the [rquote] tag, create one now!)";
	$crq_txt{'2b'} = "Enter each quote on a seperate line in the box provided. You may use HTML and ubbc tags in your random quotes, but be careful of certain character combinations in your HTML tags which could be mistaken for ubbc code. (In particular, make sure urls are surrounded by &quot;double quotes&quot;, and watch out for anything that could be interpreted as a smiley.)";
	$crq_txt{'3'} = "Select Catagory to edit";
	$crq_txt{'4'} = "-= New Catagory =-";
	$crq_txt{'5'} = "Enter Catagory Name";
	$crq_txt{'6'} = "Catagory Name not specified!";
	$crq_txt{'7'} = "The Catagory Name contains one or more illegal characters.";
	$crq_txt{'8'} = "Are you sure you want to delete this catagory?";
### Catagorised Random Quotes ###

</add before>

#############################################################################################################

<edit file>
Sources/Admin.pl
</edit file>

<search for> 
        - <a href="$cgi;action=modagreement">$txt{'764'}</a><br>
</search for> 
 
<add after> 
        - <a href="$cgi;action=modquotes">$crq_txt{'1'}</a><br> 
</add after> 

<search for> 
sub FullStats {
</search for> 
 
<add before> 
sub ModifyQuotes { 
	&is_admin; 
	my( $filename, $quotes_file, $quotes_txt ); 
	$filename = $FORM{'file'} || $INFO{'file'}; 
	$quotes_file = qq~$vardir/$filename.rnd~; 
	if (-e $quotes_file) { 
		fopen(FILE, $quotes_file); 
			while( my $line = <FILE> ) { 
				&ToHTML($line); 
				$quotes_txt .= qq~$line~; 
			} 
		fclose(FILE); 
	} else { 
		$quotes_txt .= ''; 
	} 

	$boardlist = qq~<option value="">$crq_txt{'4'}\n~;

	opendir (DIRECTORY,"$vardir");
	@dirdata = readdir(DIRECTORY);
	closedir (DIRECTORY);
	@datdata = grep(/\.rnd$/,@dirdata);
	foreach $tmp_filename (@datdata) {
		($tmp_filename, $dummy) = split (/\./, $tmp_filename);
	       	if ($tmp_filename eq $filename) {
			$boardlist .= qq~<option value=";file=$tmp_filename" selected>$tmp_filename\n~;
		} else {
			$boardlist .= qq~<option value=";file=$tmp_filename">$tmp_filename\n~;
		}
	}

	$yymain .= qq~ 
<table border="0" align="center" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor" width="80%">
  <tr>
    <td>
      <table width="100%" border="0" cellspacing="1" cellpadding="4">
        <tr> 
          <td class="titlebg" bgcolor="$color{'titlebg'}"><img src="$imagesdir/xx.gif" alt="" border="0"> <font size="2" class="text1" color="$color{'titletext'}"><b>$crq_txt{'1'}</b></font></td> 
        </tr><tr> 
          <td class="windowbg" bgcolor="$color{'windowbg'}"><br><font size="1">$crq_txt{'2a'}<br><br>$crq_txt{'2b'}</font><br><br></td> 
        </tr><tr>
          <td class="catbg" bgcolor="$color{'catbg'}" align="center">
            <form action="$cgi;action=modquotes" method="POST" style="display:inline">
              <font size="2"><b>$crq_txt{'3'}:</b> 
              <select name="file" size="1" onchange="javascript:window.location.href='$cgi;action=modquotes'+this.options[this.selectedIndex].value" style="font-size : 7pt">
              $boardlist
              </select>
              <noscript>
                <input type="submit" size="1" value="$txt{'462'}" style="font-size : 7pt">        
              </noscript>
              </font>
            </form>
          </td>
        </tr>
        </tr><tr> 
          <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><font size=2> 
          <form name="mod_quotes" action="$cgi;action=modquotes2" method="POST" onSubmit="javascript: this.save.disabled=true;~;
	if ($filename) {$yymain .= qq~ this.remove.disabled=true;~;}
	$yymain .= qq~">
          <input type="hidden" name="button" value="0"><br>~;
 
	if (!$filename) { $yymain .= qq~ 
          $crq_txt{'5'}: &nbsp; <input type="text" name="filename" size="40"><br><br>~;
	} else { $yymain .= qq~ 
          <input type="hidden" name="filename" value="$filename">~;
	}
 
	$yymain .= qq~ 
          <textarea rows="10" cols="70" wrap="virtual" name="quotes_txt" style="width:98%">$quotes_txt</textarea> 
          <br><br>
          <input name="save" type="submit" value="$txt{'10'}" onclick="javascript:window.document.mod_quotes.button.value = '0';">~;

	if ($filename) {
	$yymain .= qq~ 
           &nbsp; <input name="remove" type="submit" value="$txt{'31'}" onclick="javascript:window.document.mod_quotes.button.value = '1'; return confirm('$crq_txt{'8'}')">~;
	}
 
	$yymain .= qq~ 
          </form></font></td> 
        </tr> 
      </table> 
    </td>
  </tr> 
</table> 
~; 
      $yytitle = "$crq_txt{'1'}"; 
      &template; 
      exit; 
} 
 
sub ModifyQuotes2 { 
	&is_admin; 
	if( !$FORM{'filename'} ) { &fatal_error($crq_txt{'6'}); } 
	$FORM{'filename'} =~ s~ ~_~; 
	if($FORM{'filename'} !~ /\A[0-9A-Za-z_]+\Z/) {&fatal_error($crq_txt{'7'}) };
	my $quotes_file = qq~$vardir/$FORM{'filename'}.rnd~; 

	if( $FORM{'button'} eq "1" ) {
		unlink $quotes_file; 
		$yySetLocation = qq~$cgi;action=modquotes~; 
	} else { 
		$FORM{'quotes_txt'} =~ tr/\r//d; 
		$FORM{'quotes_txt'} =~ s~\A\n~~; 
		$FORM{'quotes_txt'} =~ s~\n\Z~~; 
		fopen(FILE, ">$quotes_file"); 
		print FILE $FORM{'quotes_txt'}; 
		fclose(FILE); 
		$yySetLocation = qq~$cgi;action=modquotes;file=$FORM{'filename'}~; 
	}
	&redirectexit; 
} 

</add before> 
 
#############################################################################################################

<edit file>
Sources/PrintPage.pl
</edit file>

<search for>  
		### Do/Undo YaBBC Stuff ###
</search for>  
  
<add after>
		$threadpost =~ s~\[rquote(.*?)\]~&rndquote($1,0)~eisg;  
</add after>

#############################################################################################################

<edit file>
Sources/Subs.pl
</edit file>

<search for>  
sub template {
</search for>  
  
<add before>
sub rndquote {     
	my $tmp_filename = $_[0] || "default"; 
	my $tmp_caller = $_[1] || 0; 
	$tmp_filename =~ s~^=~~; 
	fopen(QUOTES, "$vardir/$tmp_filename.rnd");      
	my @quotes = <QUOTES>;     
	fclose(QUOTES);  
	my $dummy = $quotes[rand(@quotes)];  
	chomp $dummy;  
	if ($tmp_caller != 2) {	$dummy =~ s~\[rquote(.*?)\]~&rndquote($1,2)~eisg; } 
	if ($tmp_caller == 1 && $enable_ubbc) {
		$message = $dummy;
		if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; }
		&DoUBBC;
		$dummy = $message;
	}
	return $dummy;    
}   

</add before>

<search for>
		$curline =~ s~<yabb\s+(\w+)>~${"yy$1"}~g;
</search for>

<add before>
		$curline =~ s~<yabb rquote(.*?)>~&rndquote($1,1)~eisg;
</add before>

#############################################################################################################

<edit file>
Sources/YaBBC.pl
</edit file>

<search for>  
sub DoUBBC {
</search for>  
  
<add after>
	$message =~ s~\[rquote(.*?)\]~&rndquote($1,0)~eisg;  
</add after> 